import Test.HUnit
import PathUtils

main = runTestTT $ test $
    [ "test_ancestors"  ~: test_ancestors,
      "test_dirname"    ~: test_dirname,
      "test_basename"   ~: test_basename,
      "test_joinPath"   ~: test_joinPath,
      "test_concatPath" ~: test_concatPath ]

test_ancestors =
    do assertEqual "1" ["/"]                (ancestors "/")
       assertEqual "2" ["/a", "/"]          (ancestors "/a")
       assertEqual "3" ["/a/b", "/a", "/"]  (ancestors "/a/b")
       assertEqual "4" ["/a/b/", "/a", "/"] (ancestors "/a/b/")
       assertEqual "5" ["a/b", "a"]         (ancestors "a/b")
       assertEqual "6" ["a/b/", "a"]        (ancestors "a/b/")
       assertEqual "7" ["a"]                (ancestors "a")
       assertEqual "8" ["."]                (ancestors ".")
       assertEqual "8" ["./"]               (ancestors "./")
       assertEqual "8" [".."]               (ancestors "..")
       assertEqual "8" ["../"]              (ancestors "../")

test_dirname =
    do assertEqual "1" "/"    (dirname "/")
       assertEqual "2" "/"    (dirname "/a")
       assertEqual "2" "/"    (dirname "/a/")
       assertEqual "3" "/a"   (dirname "/a/b")
       assertEqual "3" "/a"   (dirname "/a/b/")
       assertEqual "4" "/a/b" (dirname "/a/b/c")
       assertEqual "4" "/a/b" (dirname "/a/b/c/")
       assertEqual "5" "a"    (dirname "a/b")
       assertEqual "5" "a"    (dirname "a/b/")
       assertEqual "6" "."    (dirname "a")
       assertEqual "6" "."    (dirname "a/")
       assertEqual "7" "."    (dirname ".")
       assertEqual "7" "."    (dirname "./")
       assertEqual "8" "."    (dirname "..")
       assertEqual "8" "."    (dirname "../")

test_basename =
    do assertEqual "1" "/"  (basename "/")
       assertEqual "2" "a"  (basename "/a")
       assertEqual "2" "a"  (basename "/a/")
       assertEqual "3" "b"  (basename "/a/b")
       assertEqual "3" "b"  (basename "/a/b/")
       assertEqual "4" "a"  (basename "a")
       assertEqual "4" "a"  (basename "a/")
       assertEqual "5" "b"  (basename "a/b")
       assertEqual "5" "b"  (basename "a/b/")
       assertEqual "6" "."  (basename ".")
       assertEqual "6" "."  (basename "./")
       assertEqual "7" ".." (basename "..")
       assertEqual "7" ".." (basename "../")

test_joinPath =
    do assertEqual "1" "/a"   (joinPath "/" "a")
       assertEqual "2" "/a/b" (joinPath "/a" "b")
       assertEqual "3" "a/b"  (joinPath "a" "b")

test_concatPath =
    do assertEqual "1" "/"    (concatPath ["/"])
       assertEqual "2" "/a"   (concatPath ["/", "a"])
       assertEqual "3" "/a/b" (concatPath ["/", "a", "b"])
       assertEqual "4" "a"    (concatPath ["a"])
       assertEqual "5" "a/b"  (concatPath ["a", "b"])
